# sharereactor.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# this tcl makes some features of www.sharereactor.com  available for irc users
# like the  release checker,  the fake  checker and the  'latest episodes'  and
# 'latest releases' lists.  the script  also checks regularly  for new releases
# and if there's one it's posted to defined irc channels, including the link to
# the release.
#
# v1.0 - first public release
#
# faketrigger           - the trigger for the fake checker,  use an edonkey2000
#			  link as parameter
# dupetrigger		- the release checker, use a searchstring like 'xxx' as
#			  parameter
# episodestrigger	- returns the latest episode releases
# releasestrigger	- returns the latest "srrellimit" general releses
# srchans		- the channels the tcl is active in, "" for all or just
#			  a list like "#channel1 #channel"
# srrellimit		- the maximum of releases that will be postet 
# srnewspostlimit	- the  maximum  number  of new releases  the bot  posts 
#			  when there are new releases on sharereactor.com, this
#			  prevents floods
# srnewspost		- 1 to enable releaseposting, 0 to disable it
# issrhub		- 1 to enable hub function, 0 to disable it, read  more
#			  about  this  future in  the header  of  the leaf  tcl 
#			  which is available @ www.domsen.org
# srleafs		- the bots the leaf tcl is running on, use "" for none
#			  or a list of bots like "bot1 bot2"
#
####### config ######################

set faketrigger ".fake"
set dupetrigger ".dupe"
set episodestrigger ".episodes"
set releasestrigger ".releases"
set srchans ""
set srrellimit "8"
set srnewspostlimit "5"
set srnewspost "1"
set issrhub "1"
set srleafs ""

####### end of config #############

bind msg - $dupetrigger msg_dupesr
bind pub - $dupetrigger pub_dupesr
bind msg - $episodestrigger msg_episodes
bind pub - $episodestrigger pub_episodes
bind msg - $releasestrigger msg_releases
bind pub - $releasestrigger pub_releases
bind msg - $faketrigger msg_fake
bind pub - $faketrigger pub_fake

bind time - "?0 * * * *" srepcheck
bind time - "?0 * * * *" srrelcheck

proc sendsrnews { arg } {
global srleafs
putlog bl
foreach bot [bots] {
if {([lsearch -exact [string tolower $srleafs] [string tolower $bot]] != -1)} {
putbot $bot "sharereactor: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc srepcheck {nick uhost hand chan arg} {
global srchans srnewspost issrhub srnewspostlimit
set counter 0
if {$srnewspost == 1 } {
putlog "sharereactor: searching for new episodes"
set srlastnews "none"
if {[file exists srep.hdl]} {
set temp [open "srep.hdl" r]
set srlastnews "[gets $temp]"
if {$srlastnews == ""} { set srlastnews "none"}
close $temp
}
set temp [open "srep.hdl" w+]
if {[catch {set sock [socket www.sharereactor.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: www.sharereactor.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
set checker 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "Latest Episodes" $bl] != -1 } {set checker 1}
if {[string first "Latest Releases" $bl] != -1 } {set checker 0}
if {[string first "release.php?id=" $bl] != -1 && $checker == 1} {
set link http://www.sharereactor.com/[string range $bl 9  [shrink - 1 "\">" 0 $bl]]
set release [string range $bl [shrink + 2 "\">" 00 $bl] [shrink - 1 </a> 0 $bl]]
puts $temp "$release <$link>"
}}}
close $sock ; close $temp
if {$srlastnews == "none" } { putlog "sharereactor: headlinefile created" ; return 0 }
set temp [open "srep.hdl" r]
set srneunews ""
while {[eof $temp] != 1  && ($counter <= $srnewspostlimit) } {
set srneunews [gets $temp]
if {($srlastnews == $srneunews)} { close $temp; return 0 }
if { $issrhub == "1" } { sendsrnews $srneunews }
incr counter 
foreach chan [channels] {
if {$srchans == "" } { putserv "privmsg $chan :(new episode) $srneunews" }
if {$srchans != "" } {
if {([lsearch -exact [string tolower $srchans] [string tolower $chan]] != -1) || ($srchans == "")} {putserv "privmsg $chan :(new episode) $srneunews"}
}
}
close $temp
}}}


proc srfake { target arg } {
if {$arg == ""} { return 0}
putlog "sharereactor: fakecheck by $target for ($arg)"
regsub " " $arg "+" arg
if {[catch {set sock [socket www.sharereactor.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /fakesearch.php?search=$arg HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: www.sharereactor.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "not found" $bl] != -1 } { putserv "privmsg $target :file not checked bei sharereactor";return 0}
if {[string first "checked and is virus free" $bl] != -1 } { putserv "privmsg $target :file is virus free";return 0}
if {[string first "You didnt enter a link!" $bl] != -1 } { putserv "privmsg $target :not a valid edonkey link" ;return 0}
if {[string first "no confirmation " $bl] != -1 } { putserv "privmsg $target :link is in the database, but not checked yet" ;return 0}
}
close $sock
}}



proc srrelcheck {nick uhost hand chan arg} {
global srchans srnewspost issrhub srnewspostlimit
set counter 0
if {$srnewspost == 1 } {
putlog "sharereactor: searching for new releases"
set srlastnews "none"
if {[file exists srrel.hdl]} {
set temp [open "srrel.hdl" r]
set srlastnews "[gets $temp]"
if {$srlastnews == ""} { set srlastnews "none"}
close $temp
}
set temp [open "srrel.hdl" w+]
if {[catch {set sock [socket www.sharereactor.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: www.sharereactor.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
set checker 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "Latest Releases" $bl] != -1 } {set checker 1}
if {[string first "release.php?id=" $bl] != -1 && $checker==1} {
set link http://www.sharereactor.com/[string range $bl 9  [shrink - 1 "\">" 0 $bl]]
set release [string range $bl [shrink + 2 "\">" 00 $bl] [shrink - 1 </a> 0 $bl]]
puts $temp "$release <$link>"
}}}
close $sock ; close $temp
if {$srlastnews == "none" } { putlog "sharereactor: headlinefile created" ; return 0 }
set temp [open "srrel.hdl" r]
set srneunews ""
while {[eof $temp] != 1  && ($counter <= $srnewspostlimit) } {
set srneunews [gets $temp]
if {($srlastnews == $srneunews)} { close $temp; return 0 }
if { $issrhub == "1" } { sendsrnews $srneunews }
incr counter
foreach chan [channels] {
if {$srchans == "" } { putserv "privmsg $chan :(new release) $srneunews" }
if {$srchans != "" } {
if {([lsearch -exact [string tolower $srchans] [string tolower $chan]] != -1) || ($srchans == "")} {putserv "privmsg $chan :(new release) $srneunews"}
}
}
close $temp
}}}



proc srdupe { target limit arg } {
if {$arg == ""} { return 0}
putlog "sharereactor: dupecheck by $target for ($arg)"
regsub " " $arg "+" arg
if {[catch {set sock [socket www.sharereactor.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /search.php?search=$arg&category=0 HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: www.sharereactor.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "No matches" $bl] != -1 } {putserv "privmsg $target :no matches found";return 0 }
if {[string first "release.php?id=" $bl] != -1} {
set link http://www.sharereactor.com/[string range $bl [shrink + 3 "f=\"" 0 $bl] [expr [string last "\">" $bl] - 1] ]
set release [string range $bl [expr [string last "\">" $bl] + 2]  [shrink - 1 </a> 0 $bl]]
}
if {[string first "width=\"20%\"><a href=\"category.php" $bl] != -1 } {
set category [string range $bl [expr [string last "\">" $bl] + 2]  [shrink - 1 </a> 0 $bl]]
putserv "privmsg $target :\[$release\] \[$category\] <$link>"
incr counter
}
if {$counter == $limit} {close $sock; return 0}
}}}



proc srepisodes { target  } {
putlog "sharereactor: episodes by $target"
if {[catch {set sock [socket www.sharereactor.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: www.sharereactor.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set checker 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "Latest Episodes" $bl] != -1 } {set checker 1}
if {[string first "Latest Releases" $bl] != -1 } {return 0}
if {[string first "release.php?id=" $bl] != -1 && $checker==1} {
set link http://www.sharereactor.com/[string range $bl 9  [shrink - 1 "\">" 0 $bl]]
set release [string range $bl [shrink + 2 "\">" 00 $bl] [shrink - 1 </a> 0 $bl]]
putserv "privmsg $target :$release <$link>"
}
}
close $sock
}}

proc srreleases {target limit} {
if {[catch {set sock [socket www.sharereactor.com 80] } sockerror]} {
puts "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: www.sharereactor.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
set checker 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "Latest Releases" $bl] != -1 } {set checker 1}
if {[string first "release.php?id=" $bl] != -1 && $checker==1} {
set link http://www.sharereactor.com/[string range $bl 9  [shrink - 1 "\">" 0 $bl]]
set release [string range $bl [shrink + 2 "\">" 00 $bl] [shrink - 1 </a> 0 $bl]]
putserv "privmsg $target :$release <$link>"
incr counter
}
if {$counter == $limit} {close $sock ; return 0 }
}}}



proc msg_dupesr { nick uhost hand arg } { global srrellimit ; srdupe $nick $srrellimit $arg }
proc pub_dupesr { nick uhost hand chan arg } { global srchans srrellimit ; if {([lsearch -exact [string tolower $srchans] [string tolower $chan]] != -1) || ($srchans == "")} { srdupe $nick $srrellimit $arg }}
proc msg_episodes { nick uhost hand arg } { srepisodes $nick }
proc pub_episodes { nick uhost hand chan arg } { global srchans ; if {([lsearch -exact [string tolower $srchans] [string tolower $chan]] != -1) || ($srchans == "")} { srepisodes $nick }}
proc msg_releases { nick uhost hand arg } { global srrellimit ; srreleases $nick $srrellimit }
proc pub_releases { nick uhost hand chan arg } { global srchans srrellimit ; if {([lsearch -exact [string tolower $srchans] [string tolower $chan]] != -1) || ($srchans == "")} { srreleases $nick $srrellimit }}
proc msg_fake { nick uhost hand arg } { srfake $nick $arg }
proc pub_fake { nick uhost hand chan arg } { global srchans; if {([lsearch -exact [string tolower $srchans] [string tolower $chan]] != -1) || ($srchans == "")} { srfake $nick $arg }}


putlog "*** sharereactor.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
